<?php

/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author        D3 Data Development - Daniel Seifert <support@shopmodule.com>
 * @link          http://www.oxidmodule.com
 */
class d3_cfg_watermark_imagetypes extends d3_cfg_mod_main
{

    protected $_sThisTemplate = 'd3_cfg_watermark_imagetypes.tpl';

    protected $_sModId = 'd3_watermark';

    protected $_sMenuItemTitle = 'd3mxwatermark';

    protected $_sMenuSubItemTitle = 'd3mxwatermark_settings';

    protected $_sWatermarkName = 'd3_watermark';

    public $aImgFormats = array(
        'icon',
        'category_icon',
        'manufacturer_icon',
        'vendor_icon',
        'category_promo_icon',
        'thumb',
        'category_thumb',
        'pic1',
        'pic2',
        'pic3',
        'pic4',
        'pic5',
        'pic6',
        'pic7',
        'pic8',
        'pic9',
        'pic10',
        'pic11',
        'pic12',
        'master',
        'zoom1',
        'zoom2',
        'zoom3',
        'zoom4',
        'zoom5',
        'zoom6',
        'zoom7',
        'zoom8',
        'zoom9',
        'zoom10',
        'zoom11',
        'zoom12'
    );

    protected $_aConfigImageSlots;

    protected $_sHelpLinkMLAdd = 'D3_WATERMARK_MAIN_HELPLINK';

    /**
     * @return array
     */
    public function getImageFormats()
    {
        if ($this->_getRegisteredImageFormats()) {
            $this->aImgFormats = array(
                'icon',
                'thumb',
                'category_icon',
                'manufacturer_icon',
                'vendor_icon',
                'category_promo_icon'
            );

            $aRegImages = $this->_getRegisteredImageFormats();

            array_walk($aRegImages, array($this, '_addImageSlot'), 'pic');
            array_walk($aRegImages, array($this, '_addImageSlot'), 'zoom');

        }

        return $this->aImgFormats;
    }

    /**
     * @return array
     */
    protected function _getRegisteredImageFormats()
    {
        if (!$this->_aConfigImageSlots) {
            $this->_aConfigImageSlots = array();

            foreach (oxRegistry::getConfig()->getConfigParam('aDetailImageSizes') as $sIdent => $sSize) {
                if ($sIdent && $sSize) {
                    $this->_aConfigImageSlots[$sIdent] = str_replace('oxpic', '', strtolower($sIdent));
                }
            }
        }

        return $this->_aConfigImageSlots;
    }

    /**
     * @param $sIdent
     * @param $sName
     * @param $sType
     */
    protected function _addImageSlot($sIdent, $sName, $sType)
    {
        $this->aImgFormats[] = $sType . $sIdent;
        unset($sName);
    }
}